"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at https://mozilla.org/MPL/2.0/.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.struct_pb2
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _DeploymentState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DeploymentStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DeploymentState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    REGISTERED: _DeploymentState.ValueType  # 0
    DEPLOYING: _DeploymentState.ValueType  # 1
    READY: _DeploymentState.ValueType  # 2
    RUNNING: _DeploymentState.ValueType  # 3
    UNDEPLOYING: _DeploymentState.ValueType  # 4
    UNDEPLOYED: _DeploymentState.ValueType  # 5
    ERROR: _DeploymentState.ValueType  # 6
    NO_RESOURCES_AVAILABLE: _DeploymentState.ValueType  # 7

class DeploymentState(_DeploymentState, metaclass=_DeploymentStateEnumTypeWrapper): ...

REGISTERED: DeploymentState.ValueType  # 0
DEPLOYING: DeploymentState.ValueType  # 1
READY: DeploymentState.ValueType  # 2
RUNNING: DeploymentState.ValueType  # 3
UNDEPLOYING: DeploymentState.ValueType  # 4
UNDEPLOYED: DeploymentState.ValueType  # 5
ERROR: DeploymentState.ValueType  # 6
NO_RESOURCES_AVAILABLE: DeploymentState.ValueType  # 7
global___DeploymentState = DeploymentState

@typing.final
class Register(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _SiteType:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _SiteTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Register._SiteType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        SLURM_SSH: Register._SiteType.ValueType  # 0
        KUBERNETES: Register._SiteType.ValueType  # 1

    class SiteType(_SiteType, metaclass=_SiteTypeEnumTypeWrapper): ...
    SLURM_SSH: Register.SiteType.ValueType  # 0
    KUBERNETES: Register.SiteType.ValueType  # 1

    @typing.final
    class ObjectiveScores(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        PERFORMANCE_FIELD_NUMBER: builtins.int
        ENERGY_FIELD_NUMBER: builtins.int
        COST_FIELD_NUMBER: builtins.int
        performance: builtins.int
        energy: builtins.int
        cost: builtins.int
        def __init__(
            self,
            *,
            performance: builtins.int = ...,
            energy: builtins.int = ...,
            cost: builtins.int = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["cost", b"cost", "energy", b"energy", "performance", b"performance"]) -> None: ...

    @typing.final
    class NodePool(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        NAME_FIELD_NUMBER: builtins.int
        CPU_FIELD_NUMBER: builtins.int
        MEMORY_FIELD_NUMBER: builtins.int
        GPU_FIELD_NUMBER: builtins.int
        MAXIMUM_TIME_IN_SEC_FIELD_NUMBER: builtins.int
        OBJECTIVE_SCORES_FIELD_NUMBER: builtins.int
        ARCHITECTURE_FIELD_NUMBER: builtins.int
        GPU_MODE_FIELD_NUMBER: builtins.int
        GPU_NUM_TOTAL_FIELD_NUMBER: builtins.int
        FILTER_NO_GPU_ACTION_FIELD_NUMBER: builtins.int
        INSTANCE_TYPE_FIELD_NUMBER: builtins.int
        name: builtins.str
        cpu: builtins.float
        memory: builtins.int
        gpu: builtins.int
        maximum_time_in_sec: builtins.float
        """TODO add gpu details support
        uint64 gpu_memory = 5;
        uint32 gpu_core = 6;
        """
        architecture: builtins.str
        gpu_mode: builtins.str
        gpu_num_total: builtins.int
        filter_no_gpu_action: builtins.bool
        instance_type: builtins.str
        @property
        def objective_scores(self) -> global___Register.ObjectiveScores: ...
        def __init__(
            self,
            *,
            name: builtins.str = ...,
            cpu: builtins.float = ...,
            memory: builtins.int = ...,
            gpu: builtins.int = ...,
            maximum_time_in_sec: builtins.float | None = ...,
            objective_scores: global___Register.ObjectiveScores | None = ...,
            architecture: builtins.str = ...,
            gpu_mode: builtins.str = ...,
            gpu_num_total: builtins.int = ...,
            filter_no_gpu_action: builtins.bool = ...,
            instance_type: builtins.str | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["_instance_type", b"_instance_type", "_maximum_time_in_sec", b"_maximum_time_in_sec", "_objective_scores", b"_objective_scores", "instance_type", b"instance_type", "maximum_time_in_sec", b"maximum_time_in_sec", "objective_scores", b"objective_scores"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["_instance_type", b"_instance_type", "_maximum_time_in_sec", b"_maximum_time_in_sec", "_objective_scores", b"_objective_scores", "architecture", b"architecture", "cpu", b"cpu", "filter_no_gpu_action", b"filter_no_gpu_action", "gpu", b"gpu", "gpu_mode", b"gpu_mode", "gpu_num_total", b"gpu_num_total", "instance_type", b"instance_type", "maximum_time_in_sec", b"maximum_time_in_sec", "memory", b"memory", "name", b"name", "objective_scores", b"objective_scores"]) -> None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_instance_type", b"_instance_type"]) -> typing.Literal["instance_type"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_maximum_time_in_sec", b"_maximum_time_in_sec"]) -> typing.Literal["maximum_time_in_sec"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_objective_scores", b"_objective_scores"]) -> typing.Literal["objective_scores"] | None: ...

    SITE_NAME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    NODE_POOLS_FIELD_NUMBER: builtins.int
    SITE_ID_FIELD_NUMBER: builtins.int
    site_name: builtins.str
    type: global___Register.SiteType.ValueType
    site_id: builtins.str
    @property
    def node_pools(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Register.NodePool]: ...
    def __init__(
        self,
        *,
        site_name: builtins.str = ...,
        type: global___Register.SiteType.ValueType = ...,
        node_pools: collections.abc.Iterable[global___Register.NodePool] | None = ...,
        site_id: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_site_id", b"_site_id", "site_id", b"site_id"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_site_id", b"_site_id", "node_pools", b"node_pools", "site_id", b"site_id", "site_name", b"site_name", "type", b"type"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["_site_id", b"_site_id"]) -> typing.Literal["site_id"] | None: ...

global___Register = Register

@typing.final
class ExecutionEnded(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _ExecutionStatus:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ExecutionStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ExecutionEnded._ExecutionStatus.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        COMPLETED: ExecutionEnded._ExecutionStatus.ValueType  # 0
        CANCELED: ExecutionEnded._ExecutionStatus.ValueType  # 1
        ERROR: ExecutionEnded._ExecutionStatus.ValueType  # 2

    class ExecutionStatus(_ExecutionStatus, metaclass=_ExecutionStatusEnumTypeWrapper): ...
    COMPLETED: ExecutionEnded.ExecutionStatus.ValueType  # 0
    CANCELED: ExecutionEnded.ExecutionStatus.ValueType  # 1
    ERROR: ExecutionEnded.ExecutionStatus.ValueType  # 2

    EXECUTION_ID_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    execution_id: builtins.str
    status: global___ExecutionEnded.ExecutionStatus.ValueType
    error_message: builtins.str
    def __init__(
        self,
        *,
        execution_id: builtins.str = ...,
        status: global___ExecutionEnded.ExecutionStatus.ValueType = ...,
        error_message: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["error_message", b"error_message", "execution_id", b"execution_id", "status", b"status"]) -> None: ...

global___ExecutionEnded = ExecutionEnded

@typing.final
class GetExecutionStateReply(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _State:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _StateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[GetExecutionStateReply._State.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        UNKNOWN: GetExecutionStateReply._State.ValueType  # 0
        RUNNING: GetExecutionStateReply._State.ValueType  # 1
        COMPLETED: GetExecutionStateReply._State.ValueType  # 2
        CANCELED: GetExecutionStateReply._State.ValueType  # 3
        ERROR: GetExecutionStateReply._State.ValueType  # 4

    class State(_State, metaclass=_StateEnumTypeWrapper): ...
    UNKNOWN: GetExecutionStateReply.State.ValueType  # 0
    RUNNING: GetExecutionStateReply.State.ValueType  # 1
    COMPLETED: GetExecutionStateReply.State.ValueType  # 2
    CANCELED: GetExecutionStateReply.State.ValueType  # 3
    ERROR: GetExecutionStateReply.State.ValueType  # 4

    EXECUTION_STATE_FIELD_NUMBER: builtins.int
    execution_state: global___GetExecutionStateReply.State.ValueType
    def __init__(
        self,
        *,
        execution_state: global___GetExecutionStateReply.State.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["execution_state", b"execution_state"]) -> None: ...

global___GetExecutionStateReply = GetExecutionStateReply

@typing.final
class InitTaskRequest(google.protobuf.message.Message):
    """Synchronous wait"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    EXECUTION_ID_FIELD_NUMBER: builtins.int
    LOG_DELIMITER_FIELD_NUMBER: builtins.int
    EXECUTOR_ID_FIELD_NUMBER: builtins.int
    execution_id: builtins.str
    log_delimiter: builtins.str
    executor_id: builtins.str
    def __init__(
        self,
        *,
        execution_id: builtins.str = ...,
        log_delimiter: builtins.str | None = ...,
        executor_id: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_executor_id", b"_executor_id", "_log_delimiter", b"_log_delimiter", "executor_id", b"executor_id", "log_delimiter", b"log_delimiter"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_executor_id", b"_executor_id", "_log_delimiter", b"_log_delimiter", "execution_id", b"execution_id", "executor_id", b"executor_id", "log_delimiter", b"log_delimiter"]) -> None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_executor_id", b"_executor_id"]) -> typing.Literal["executor_id"] | None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_log_delimiter", b"_log_delimiter"]) -> typing.Literal["log_delimiter"] | None: ...

global___InitTaskRequest = InitTaskRequest

@typing.final
class TaskNewLogLines(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TASK_ID_FIELD_NUMBER: builtins.int
    LOGS_FIELD_NUMBER: builtins.int
    task_id: builtins.str
    logs: builtins.str
    def __init__(
        self,
        *,
        task_id: builtins.str = ...,
        logs: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["logs", b"logs", "task_id", b"task_id"]) -> None: ...

global___TaskNewLogLines = TaskNewLogLines

@typing.final
class TaskCompleted(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Status:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _StatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[TaskCompleted._Status.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        SUCCESS: TaskCompleted._Status.ValueType  # 0
        ERROR: TaskCompleted._Status.ValueType  # 1

    class Status(_Status, metaclass=_StatusEnumTypeWrapper): ...
    SUCCESS: TaskCompleted.Status.ValueType  # 0
    ERROR: TaskCompleted.Status.ValueType  # 1

    @typing.final
    class OutputFile(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        OUTPUT_NAME_FIELD_NUMBER: builtins.int
        FILE_PATH_FIELD_NUMBER: builtins.int
        MIMETYPE_FIELD_NUMBER: builtins.int
        ENCODING_FIELD_NUMBER: builtins.int
        SIZE_IN_BYTES_FIELD_NUMBER: builtins.int
        output_name: builtins.str
        file_path: builtins.str
        mimetype: builtins.str
        encoding: builtins.str
        size_in_bytes: builtins.int
        def __init__(
            self,
            *,
            output_name: builtins.str = ...,
            file_path: builtins.str = ...,
            mimetype: builtins.str | None = ...,
            encoding: builtins.str | None = ...,
            size_in_bytes: builtins.int = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["_encoding", b"_encoding", "_mimetype", b"_mimetype", "encoding", b"encoding", "mimetype", b"mimetype"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["_encoding", b"_encoding", "_mimetype", b"_mimetype", "encoding", b"encoding", "file_path", b"file_path", "mimetype", b"mimetype", "output_name", b"output_name", "size_in_bytes", b"size_in_bytes"]) -> None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_encoding", b"_encoding"]) -> typing.Literal["encoding"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_mimetype", b"_mimetype"]) -> typing.Literal["mimetype"] | None: ...

    TASK_ID_FIELD_NUMBER: builtins.int
    OUTPUTS_FIELD_NUMBER: builtins.int
    OUTPUT_FILES_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    END_TIME_FIELD_NUMBER: builtins.int
    HTTP_STATUS_CODE_FIELD_NUMBER: builtins.int
    ERROR_MESSAGE_FIELD_NUMBER: builtins.int
    task_id: builtins.str
    status: global___TaskCompleted.Status.ValueType
    http_status_code: builtins.int
    error_message: builtins.str
    @property
    def outputs(self) -> google.protobuf.struct_pb2.Struct: ...
    @property
    def output_files(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___TaskCompleted.OutputFile]: ...
    @property
    def end_time(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    def __init__(
        self,
        *,
        task_id: builtins.str = ...,
        outputs: google.protobuf.struct_pb2.Struct | None = ...,
        output_files: collections.abc.Iterable[global___TaskCompleted.OutputFile] | None = ...,
        status: global___TaskCompleted.Status.ValueType = ...,
        end_time: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        http_status_code: builtins.int | None = ...,
        error_message: builtins.str | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_error_message", b"_error_message", "_http_status_code", b"_http_status_code", "end_time", b"end_time", "error_message", b"error_message", "http_status_code", b"http_status_code", "outputs", b"outputs"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_error_message", b"_error_message", "_http_status_code", b"_http_status_code", "end_time", b"end_time", "error_message", b"error_message", "http_status_code", b"http_status_code", "output_files", b"output_files", "outputs", b"outputs", "status", b"status", "task_id", b"task_id"]) -> None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_error_message", b"_error_message"]) -> typing.Literal["error_message"] | None: ...
    @typing.overload
    def WhichOneof(self, oneof_group: typing.Literal["_http_status_code", b"_http_status_code"]) -> typing.Literal["http_status_code"] | None: ...

global___TaskCompleted = TaskCompleted

@typing.final
class ActionDeploymentUpdated(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEPLOYMENT_ID_FIELD_NUMBER: builtins.int
    DEPLOYMENT_STATE_FIELD_NUMBER: builtins.int
    LOGS_FIELD_NUMBER: builtins.int
    deployment_id: builtins.str
    deployment_state: global___DeploymentState.ValueType
    logs: builtins.str
    def __init__(
        self,
        *,
        deployment_id: builtins.str = ...,
        deployment_state: global___DeploymentState.ValueType = ...,
        logs: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["deployment_id", b"deployment_id", "deployment_state", b"deployment_state", "logs", b"logs"]) -> None: ...

global___ActionDeploymentUpdated = ActionDeploymentUpdated

@typing.final
class ActionDeploymentCurrentState(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEPLOYMENT_STATE_FIELD_NUMBER: builtins.int
    deployment_state: global___DeploymentState.ValueType
    def __init__(
        self,
        *,
        deployment_state: global___DeploymentState.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["deployment_state", b"deployment_state"]) -> None: ...

global___ActionDeploymentCurrentState = ActionDeploymentCurrentState

@typing.final
class ActionDeploymentNewLogLines(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    DEPLOYMENT_ID_FIELD_NUMBER: builtins.int
    EXECUTOR_ID_FIELD_NUMBER: builtins.int
    LOGS_FIELD_NUMBER: builtins.int
    deployment_id: builtins.str
    executor_id: builtins.str
    logs: builtins.str
    def __init__(
        self,
        *,
        deployment_id: builtins.str = ...,
        executor_id: builtins.str = ...,
        logs: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["deployment_id", b"deployment_id", "executor_id", b"executor_id", "logs", b"logs"]) -> None: ...

global___ActionDeploymentNewLogLines = ActionDeploymentNewLogLines

@typing.final
class RecommendationsVPA(google.protobuf.message.Message):
    """Recommendation of VPA"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    @typing.final
    class Recommendation(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        CONTAINER_IMAGE_FIELD_NUMBER: builtins.int
        GPU_MIG_INSTANCE_FIELD_NUMBER: builtins.int
        MEMORY_FIELD_NUMBER: builtins.int
        IS_OOM_BUMPUP_FIELD_NUMBER: builtins.int
        IS_GPUOOM_BUMPUP_FIELD_NUMBER: builtins.int
        container_image: builtins.str
        gpu_mig_instance: builtins.str
        """3 - 9 reserved for other keys"""
        memory: builtins.int
        """No need to update cpu values to runner. Let Worker do by itself.
        float cpu = 10;
        """
        is_oom_bumpup: builtins.bool
        is_gpuoom_bumpup: builtins.bool
        def __init__(
            self,
            *,
            container_image: builtins.str = ...,
            gpu_mig_instance: builtins.str = ...,
            memory: builtins.int = ...,
            is_oom_bumpup: builtins.bool = ...,
            is_gpuoom_bumpup: builtins.bool = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["container_image", b"container_image", "gpu_mig_instance", b"gpu_mig_instance", "is_gpuoom_bumpup", b"is_gpuoom_bumpup", "is_oom_bumpup", b"is_oom_bumpup", "memory", b"memory"]) -> None: ...

    RECOMMENDATIONS_FIELD_NUMBER: builtins.int
    @property
    def recommendations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___RecommendationsVPA.Recommendation]: ...
    def __init__(
        self,
        *,
        recommendations: collections.abc.Iterable[global___RecommendationsVPA.Recommendation] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["recommendations", b"recommendations"]) -> None: ...

global___RecommendationsVPA = RecommendationsVPA
